; PODPROGRAMY UATWIAJCE OBSUG WEWNTRZNEJ PAMICI EEPROM
; Rafa Baranowski (C) 2004
;
; Etykiety procedur:
; 	Zapisz_EE		- zapis bajtu w pamici EEPROM
;	Czytaj_EE		- odczyt bajtu z pamici EEPROM
;


;****************************************************************
;	PROCEDURA ZAPISUJCA BAJT W PAMICI EEPROM
;
; Parametry:
;	XH	- MSB adresu modyfikowanej komrki pamici EEPROM
;	XL	- LSB adresu modyfikowanej komrki pamici EEPROM
;	R16	- rejestr wartoci zapisywanej w pamici
;
; Uwagi:
;	- procedura automatycznie wcza zezwolenie na przerwania (I=1)
;
Zapisz_EE:
	push	R17
Zap_EE_1:
	in	R17, EECR	
	sbrc	R17, EEWE	; oczekiwanie na zakoczenie ewentualnego
	rjmp	Zap_EE_1	;   procesu zapisu pamici

	out	EEARH, XH	; okrel MSB adresu zapisywanej komrki
	out	EEARL, XL	; okrel LSB adresu zapisywanej komrki
	out	EEDR, R16	; okrel warto zapisywan

	ldi	R17, 1<<EEMWE
	cli			; blokuj przerwania na czas sekwencji zapisu
	out	EECR, R17	; wcz tymczasowe zezwolenie na zapis
	ldi	R17, 1<<EEWE
	out	EECR, R17	; przeprowad zapis
	sei			; odblokuj przerwania

	pop	R17
	ret


;****************************************************************
;	PROCEDURA ODCZYTUJCA BAJT Z PAMICI EEPROM
;
; Parametry:
;	XH	- MSB adresu komrki odczytywanej z pamici EEPROM
;	XL	- LSB adresu komrki odczytywanej z pamici EEPROM
;
; Wartoci wyjciowe:
;	R16	- rejestr wartoci odczytanej z pamici
;
Czytaj_EE:
	in	R16, EECR
	sbrc	R16, EEWE	; oczekiwanie na zakoczenie ewentualnego
	rjmp	Czytaj_EE	;   procesu zapisu pamici

	out	EEARH, XH	; okrel MSB adresu odczytywanej komrki
	out	EEARL, XL	; okrel LSB adresu odczytywanej komrki

	ldi	R16, 1<<EERE
	out	EECR, R16	; odczytaj pami EEPROM
	in	R16, EEDR	; i umie wynik w rejestrze R16

	ret
