; Kalkulator, obsuga wywietlacza multipleksowanego
; Rafa Baranowski (C) 2004

.INCLUDE "m16def.inc"		; SEGMENT DEKLARACJI

.EQU	SYS_FREQ	= 1		; czstotliwo pracy w MHz

.EQU	K_KLAW	= DDRB	; rejestr kierunku portu klawiatury
.EQU	O_KLAW	= PORTB	; rejestr wyjciowy portu klawiatury
.EQU	I_KLAW	= PINB	; rejestr wejciowy portu klawiatury
.EQU	K_KL_WCISN	= DDRD	; rejestr kierunku linii "kl. wcinity"
.EQU	O_KL_WCISN	= PORTD	; rejestr wyjciowy linii "kl. wcinity"
.EQU	I_KL_WCISN	= PIND	; rejestr wejciowy linii "kl. wcinity"
.EQU	KL_WCISN	= 2		; nr linii dla sygnau "kl. wcinity"

.EQU	K_W7S_SEG	= DDRA	; rejestr kierunku portu segmentw
.EQU	O_W7S_SEG	= PORTA	; rejestr wyjciowy portu segmentw
.EQU	K_W7S_KOL	= DDRD	; rejestr kierunku portu kolumn
.EQU	O_W7S_KOL	= PORTD	; rejestr wyjciowy portu kolumn
.EQU	W7S_KOL0	= 7		; nr linii dla kolumny 1. (cyfra najmodsza)
.EQU	W7S_KOL1	= 6		; nr linii dla kolumny 2.
.EQU	W7S_KOL2	= 5		; nr linii dla kolumny 3.
.EQU	W7S_KOL3	= 4		; nr linii dla kolumny 4. (cyfra najstarsza)

.DEF	ARG		= R24		; rejestr argumentu
.DEF	ANS		= R25		; rejestr wyniku



.DSEG					; SEGMENT DANYCH
.ORG 0x0060				; pocztek pamici SRAM

Klaw_inf:		.BYTE	1	; zmienna stanu klawiatury matrycowej

W7s_kolumna:	.BYTE 1	; zmienna numeru aktywnej kolumny
W7s_cyfry:		.BYTE 4	; tablica 4. zmiennych przechowujcych
					;   wartoci aktualnie wywietlanych cyfr


.CSEG					; SEGMENT PROGRAMU
.ORG	0				; wektor zerowania
	jmp	Reset			; skok do procedury inicjalizujcej

.ORG	INT0addr			; wektor przerwania INT0
	jmp	Odczyt_klawiatury	; skok do procedury odczytujcej stan klawiatury

.ORG	OC0addr			; wektor przerwania OC0
	jmp	Multipleks_w7s	; skok do procedury obsugi wywietlacza multipl.



Reset:				; podprogram inicjalizujcy
	ldi	R17, high(RAMEND)
	ldi	R16, low(RAMEND)
	out	SPH, R17
	out	SPL, R16		; inicjalizacja wskanika stosu

	clr	R16
	ldi	R17, 6		; R17 okrela liczb zajtych przez zmienne komrek
	ldi	XH, high(0x0060)	;   pamici SRAM (licznik poniszej ptli)
	ldi	XL, low(0x0060)	; X wskazuje na pocztek pamici SRAM
Reset_1:				; ptla zerujca zawarto wszystkich uywanych
	st	X+, R16		;   przez zmienne komrek pamici SRAM
	dec	R17
	brne	Reset_1

	clr	ANS			; zerowanie rejestru wyniku (R25)
	clr	ARG			; zerowanie rejestru argumentu (R24)

	rcall	Ini_klawiatury	; inicjalizacja klawiatury matrycowej
	rcall	Ini_w7s		; inicjalizacja wywietlacza multipleksowanego

	sei				; odblokowanie przerwa


Petla:				; ptla gwna programu	
	lds	R16, Klaw_inf	
	sbrs	R16, 7
	rjmp	Petla			; oczekuj na wcinicie klawisza

	lds	R16, Klaw_inf	; zapisz warto klawisza w zmiennej R16
	cbr	R16, 1<<7		;   i wyzeruj bit informujcy o jego wciniciu

	cpi	R16, 0x0A		; jeli warto klawisza jest wiksza lub rwna 10,
	brsh	Petla_0		;   to sprawdzaj dalej
	rjmp	Wybrano_cyfre	; jeli warto klawisza bya mniejsza ni 10,
					;   to przejd do wprowadzania nowej cyfry
Petla_0:
	brne	Petla_1		; jeli warto klawisza bya rwna 10 (kl. "A"),
	rjmp	Wybrano_dodaj	;   to przejd do dodawania

Petla_1:
	cpi	R16, 0x0B		; jeli warto klawisza jest rna od 11 (kl. "B"),
	brne	Petla_2		;   to sprawdzaj dalej
	rjmp	Wybrano_odejmij	; jeli warto klawisza jest rwna 11 (kl. "B"),
					;   to przejd do odejmowania
Petla_2:
	cpi	R16, 0x0F		; jeli warto klawisza jest rna od 15 (kl. "*"),
	brne	Petla_3		;   to sprawdzaj dalej
	rjmp	Wybrano_mnoz	; jeli warto klawisza jest rwna 15 (kl. "*"),
					;   to przejd do mnoenia
Petla_3:
	cpi	R16, 0x0E		; jeli warto klawisza jest rna od 14 (kl. "#"),
	brne	Petla_4		;   to sprawdzaj dalej
	rjmp	Wybrano_wprowadz	; jeli warto klawisza jest rwna 14 (kl. "#"),
					;   to przejd do wprowadzania argumentu
Petla_4:
	cpi	R16, 0x0C		; jeli warto klawisza jest rna od 12 (kl. "C"),
	brne	Petla_5		;   to sprawdzaj dalej
	rjmp	Wybrano_wymaz	; jeli warto klawisza jest rwna 12 (kl. "C"),
					;   to przejd do wymazywania argumentu

Petla_5:				; jeli warto klawisza jest inna (kl. "D"),
	rjmp	Wybrano_zeruj	;   to przejd do zerowania wyniku i argumentu

Wybrano_cyfre:			; jeli wybrano klawisze "0".."9", to..
	ldi	R17, 10
	mul	ARG, R17		;   pomn aktualny argument przez 10
	mov	ARG, R0
	add	ARG, R16		;   dodaj do niego wprowadzon cyfr (R16)
	mov	R16, ARG
	rcall	Pokaz_bajt_w7s	;   wywietl argument
	rjmp	Koniec_operacji	;   skocz do zakoczenia

Wybrano_dodaj:			; jeli wybrano klawisz "A", to..
	add	ANS, ARG		;   dodaj argument do wyniku
	mov	R16, ANS
	rcall	Pokaz_bajt_w7s	;   wywietl wynik
	clr	ARG			;   wyzeruj warto argumentu
	rjmp	Koniec_operacji	;   skocz do zakoczenia

Wybrano_odejmij:			; jeli wybrano klawisz "B", to..
	sub	ANS, ARG		;   odejmij argument od wyniku
	mov	R16, ANS
	rcall	Pokaz_bajt_w7s	;   wywietl wynik
	clr	ARG			;   wyzeruj warto argumentu
	rjmp	Koniec_operacji	;   skocz do zakoczenia

Wybrano_mnoz:			; jeli wybrano klawisz "*", to..
	mul	ANS, ARG		;   pomn wynik przez argument
	mov	ANS, R0
	mov	R16, ANS
	rcall	Pokaz_bajt_w7s	;   wywietl wynik
	clr	ARG			;   wyzeruj warto argumentu
	rjmp	Koniec_operacji	;   skocz do zakoczenia

Wybrano_wprowadz:			; jeli wybrano klawisz "#", to..
	mov	ANS, ARG		;   wprowad argument w miejsce wyniku
	clr	ARG			;   wyzeruj warto argumentu
	rjmp	Koniec_operacji	;   skocz do zakoczenia

Wybrano_wymaz:			; jeli wybrano klawisz "C", to..
	clr	ARG			;   wyzeruj warto argumentu
	mov	R16, ARG
	rcall	Pokaz_bajt_w7s	;   wywietl argument
	rjmp	Koniec_operacji	; skocz do zakoczenia

Wybrano_zeruj:			; jeli wybrano klawisz "D", to..
	clr	ARG			;   wyzeruj warto argumentu
	clr	ANS			;   wyzeruj warto wyniku
	mov	R16, ANS
	rcall	Pokaz_bajt_w7s	;   wywietl wynik

Koniec_operacji:
	lds	R16, Klaw_inf
	sbrc	R16, 7
	rjmp	Koniec_operacji	; oczekiwanie na puszczenie klawisza


	rjmp	Petla			; zaptl program


					; DOCZANE PODPROGRAMY
.INCLUDE "czekaj_ms.inc"	;   oczekiwanie milisekundowe
.INCLUDE "czekaj_us.inc"	;   oczekiwanie mikrosekundowe
.INCLUDE "klaw_mat.inc"		;   obsuga klawiatury matrycowej
.INCLUDE "w7s_mul.inc"		;   wywietlacz multipleksowany LED
